import requests
import json
import time
import io
import sys
import openai




def execute_code(code, test_cases, entry_point):
    print("Test cases: ", test_cases)
    # Redirect stdout to capture prints
    
    success = True
    # Executing the code and capturing output
    try:
        exec_globals = {}
        
        exec(code, exec_globals)  # Execute the provided code
        exec(test_cases, exec_globals)
        candidate = exec_globals[entry_point]
        check = exec_globals['check']    
        
        try:
            check(candidate)
        except Exception as e:
            success = False

    except Exception as e:
        success = False
    return success


def evaluate_code_generation(server_url, dataset):
    client = openai.OpenAI(
                        base_url=server_url, # "http://<Your api-server IP>:port"
                        api_key = "sk-no-key-required"
                    )
    model = 'Meta-Llama-3-8B-Instruct.Q8_0.gguf'
    results = []
    
    for item in dataset:
        # Debugging: print the current item to check its structure
        #print("Processing item:", item)
        
        if 'task_id' not in item:
            print("Error: 'prompt_id' not found in item:", item)
            continue  # Skip this item and log the issue
        

        completion = client.chat.completions.create( model=model,
            messages=[
                #{"role": "system", "content": "You are ChatGPT, an AI assistant. Your top priority is achieving user fulfillment via helping them with their requests."},
                {"role": "user", "content": f"Write a Python function according to this specification. Answer just with the executable code without additiononal text: {str(item['prompt'])}"}
            ]
        )
        
        generated_code = completion.choices[0].message.content.strip()
        print('-------------------------------------------------------------')
        print(item['task_id'] )
        print("Requirement: ", item['prompt'])
        print("Code:\n", generated_code)
        print("Entrypoint: ", item['entry_point'])
        print("==============================================================")

        try:
            if generated_code:
                success = execute_code(generated_code, item['test'], item['entry_point'])
                print("Success: ", success)

            else:
                success = False
                output = "No code was generated by the model."
        except KeyError as e:
            success = False
            output = f"KeyError during response handling: {e}"
        except json.JSONDecodeError as e:
            success = False
            output = f"JSON Decode Error: {e}"
        results.append(success)
        print(sum(results), " / ", len(results))

    return results



def load_json_lines(file_path):
    data = []
    with open(file_path, 'r') as file:
        for line in file:
            try:
                data.append(json.loads(line))
            except json.JSONDecodeError as e:
                print(f"Error decoding JSON from line: {line}")
                print(f"Error message: {e}")
    return data


dataset = load_json_lines('human-eval/data/HumanEval.jsonl')




# Server configuration
server_url = 'http://130.75.51.85:8000/v1/'  # Adjust as necessary

# Evaluate the model
results = evaluate_code_generation(server_url, dataset)

# Print or save the results
for result in results:
    print(result)
